/***************************************************************************
                          main.cpp  -  description
                             -------------------
    begin                : Sam Jul 19 16:00:29 CEST 2003
    copyright            : (C) 2003 by Bernd Lachner
    email                : dev@lachner-net.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifdef QTOPIA
#include <qpe/qpeapplication.h>
#else
#include <qapplication.h>
#endif
#include <qfont.h>
#include <qstring.h>
#include <qtextcodec.h>
#include <qtranslator.h>
#include <qdir.h>
#include <qwidgetstack.h>
#include <qmessagebox.h>

#include "zshopimainwidget.h"
#include "zshopiview.h"
#include "zshopigoodsview.h"
#include "zshopiadddialog.h"

int main(int argc, char *argv[])
{
#ifdef QTOPIA
  QPEApplication a(argc, argv);
#else
  QApplication a(argc, argv);
#endif
  a.setFont(QFont("helvetica", 10));
  QTranslator tor( 0 );
  // set the location where your .qm files are in load() below as the last parameter instead of "."
  // for development, use "/" to use the english original as
  // .qm files are stored in the base project directory.
  tor.load( QString("zshopi.") + QTextCodec::locale(), "." );
  a.installTranslator( &tor );

  try
  {
    // Open database and create tables if necessary
    QSQLite oSQLite(QDir::homeDirPath()+"/zshopi.dbl");
    if (!oSQLite.IsInTable("sqlite_master", "type = 'table' and name = 'goods'"))
      oSQLite.CreateTable("goods", "id integer primary key, name, category, amountgroup");
    if (!oSQLite.IsInTable("sqlite_master", "type = 'table' and name = 'category'"))
      oSQLite.CreateTable("category", "id integer primary key, name");
    if (!oSQLite.IsInTable("sqlite_master", "type = 'table' and name = 'shops'"))
      oSQLite.CreateTable("shops", "id integer primary key, name");
    if (!oSQLite.IsInTable("sqlite_master", "type = 'table' and name = 'cart'"))
      oSQLite.CreateTable("cart", "id integer primary key, goodid, shopid, amount, done");
    if (!oSQLite.IsInTable("sqlite_master", "type = 'table' and name = 'amountgroups'"))
      oSQLite.CreateTable("amountgroups", "id integer primary key, name, unit, numlist");
                                                        
    ZShopiMainWidget *poWidgetStack = new ZShopiMainWidget(&oSQLite);

#ifdef QTOPIA
    a.showMainWidget(poWidgetStack);
#else
    a.setMainWidget(poWidgetStack);
#endif

    poWidgetStack->show();

    return a.exec();
  }
  catch (QSQLiteException *oException)
  {
    QMessageBox::critical( 0, QObject::tr("Database error!"), oException->getMessage());
  }
}


