/***************************************************************************
                          zshopiadddialog.cpp  -  description
                             -------------------
    begin                : Son Jul 20 2003
    copyright            : (C) 2003 by Bernd Lachner
    email                : dev@lachner-net.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "zshopiadddialog.h"

#include <qcombobox.h>
#include <qlabel.h>
#include <qlayout.h>
#include <qpushbutton.h>
#include <qmessagebox.h>
#include <qgroupbox.h>

ZShopiAddDialog::ZShopiAddDialog(QSQLite *poSQLite, QWidget* parent, const char* name, bool modal, WFlags fl)
: ZShopiAddDialogDesign(parent, name, modal, fl),
  m_poSQLite(poSQLite)
{
  ComboBoxGoodsGroups->insertItem(tr("- All -"));
  ComboBoxGoods->insertItem(tr("- Nothing -"));
  ComboBoxAmount->setEnabled(FALSE);
  
  m_poSQLite->Select(this, SLOT(RowDataShopList(int, char**, char**)), "shops", "*", "", "name");
  m_poSQLite->Select(this, SLOT(RowDataGoodsGroups(int, char**, char**)), "category", "*", "", "name");
  m_poSQLite->Select(this, SLOT(RowDataGoods(int, char**, char**)), "goods", "*","","name");

#ifdef QTOPIA
  PushButtonAccept->hide();
  PushButtonCancel->hide();
  LayoutMain->removeChild(LayoutButtons);
  delete LayoutButtons;
#endif
  adjustSize();
}


ZShopiAddDialog::ZShopiAddDialog(QSQLite *poSQLite, const QString &qsID, QWidget* parent, const char* name, bool modal, WFlags fl)
: ZShopiAddDialogDesign(parent, name, modal, fl),
  m_poSQLite(poSQLite),
  m_qsID(qsID)
{
  ComboBoxGoodsGroups->insertItem(tr("- All -"));
  ComboBoxGoods->insertItem(tr("- Nothing -"));
  ComboBoxAmount->setEnabled(FALSE);

  m_poSQLite->Select(this, SLOT(RowDataShopList(int, char**, char**)), "shops");
  m_poSQLite->Select(this, SLOT(RowDataGoodsGroups(int, char**, char**)), "category");
  m_poSQLite->Select(this, SLOT(RowDataGoods(int, char**, char**)), "goods", "*","","name");

  //Selected good needs to be choosed in Input's
  m_poSQLite->Select(this, SLOT(RowDataSelectedGood(int, char**, char**)), "cart", "*", "id = " + qsID);

  //Find AmountGroup for the Good
  m_poSQLite->Select(this, SLOT(RowDataFindAmountGroupForGood(int, char**, char**)), "amountgroups", "amountgroups.unit , amountgroups.numlist", "amountgroups.id = (select goods.amountgroup from goods where goods.id = " + m_poSQLite->MakeCharVal(m_qmapGoodID[ComboBoxGoods->currentItem()]) + " );");

  TextLabelGoodsGroups->hide();
  ComboBoxGoodsGroups->hide();

  //change text at dialogs for Editing
  GroupBox->setTitle(tr("Edit good at shopping-list"));
  setCaption(tr("Edit good"));
  

#ifdef QTOPIA
  PushButtonAccept->hide();
  PushButtonCancel->hide();
  LayoutMain->removeChild(LayoutButtons);
  delete LayoutButtons;
#endif
  adjustSize();
}

ZShopiAddDialog::~ZShopiAddDialog()
{
}

void ZShopiAddDialog::RowDataShopList(int iColumns, char** aszData, char** aszColumnNames)
{
  ComboBoxShops->insertItem(aszData[1]);
  int iIndex = ComboBoxShops->count()-1;
  m_qmapShopID[iIndex] = QString(aszData[0]);
}

void ZShopiAddDialog::RowDataGoodsGroups(int iColumns, char** aszData, char** aszColumnNames)
{
  ComboBoxGoodsGroups->insertItem(aszData[1]);
  int iIndex = ComboBoxGoodsGroups->count()-1;
  m_qmapGoodsGroupID[iIndex] = QString(aszData[0]);
}

void ZShopiAddDialog::RowDataGoods(int iColumns, char** aszData, char** aszColumnNames)
{
  ComboBoxGoods->insertItem(aszData[1]);
  int iIndex = ComboBoxGoods->count()-1;
  m_qmapGoodID[iIndex] = QString(aszData[0]);
}

void ZShopiAddDialog::RowDataSelectedGood(int iColumns, char** aszData, char** aszColumnNames)
{
  TComboMap::Iterator it;
  for (it = m_qmapGoodID.begin(); it != m_qmapGoodID.end(); ++it)
  {
    if (it.data() == aszData[1])
    {
      ComboBoxGoods->setCurrentItem(it.key());
      break;
    }
  }
  for (it = m_qmapShopID.begin(); it != m_qmapShopID.end(); ++it)
  {
    if (it.data() == aszData[2])
    {
      ComboBoxShops->setCurrentItem(it.key());
      break;
    }
  }

  // Remember the amount n umber for later

  m_qsSelectedAmount = aszData[3];
  m_qsSelectedAmount.truncate(m_qsSelectedAmount.find(' '));
  
  ComboBoxGoods->setEnabled(FALSE);
  ComboBoxGoodsGroups->setEnabled(FALSE);
}

void ZShopiAddDialog::slotGoodsGroupChanged(int iIndex)
{
  PushButtonAccept->setEnabled(FALSE);
  ComboBoxGoods->clear();
  ComboBoxGoods->insertItem(tr("- Nothing -"));
  ComboBoxAmount->clear();
  ComboBoxAmount->setEnabled(FALSE);
  TextLabelUnit->setText(tr("unit"));
  if (iIndex == 0)
  {
    m_poSQLite->Select(this, SLOT(RowDataGoods(int, char**, char**)), "goods", "*", "", "name");
  }
  else
  {
    m_poSQLite->Select(this, SLOT(RowDataGoods(int, char**, char**)), "goods", "id, name", "category = " + m_qmapGoodsGroupID[iIndex], "name");
  }
}

void ZShopiAddDialog::slotGoodChanged(int iIndex)
{
  if (iIndex != 0)
  {
    m_poSQLite->Select(this, SLOT(RowDataFindAmountGroupForGood(int, char**, char**)), "amountgroups", "amountgroups.unit , amountgroups.numlist", "amountgroups.id = (select goods.amountgroup from goods where goods.id = " + m_poSQLite->MakeCharVal(m_qmapGoodID[iIndex]) + " );");
    PushButtonAccept->setEnabled(TRUE);
  }
  else
  {
    PushButtonAccept->setEnabled(FALSE);
  }
}

void ZShopiAddDialog::RowDataFindAmountGroupForGood(int iColumns, char** aszData, char** aszColumnNames)
{
  TextLabelUnit->setText(aszData[0]);
  ComboBoxAmount->setEnabled(true);
  QString qsNumList = aszData[1];
  ComboBoxAmount->clear();
  unsigned int uiPos = 0;
  // Creates the numbers from the numlist for the ComboBox
  while (uiPos < qsNumList.length())
  {
    int iSeperator = qsNumList.find(',', uiPos);
    if (iSeperator == -1)
      iSeperator = qsNumList.length();
    ComboBoxAmount->insertItem(qsNumList.mid(uiPos, iSeperator-uiPos));
    uiPos = iSeperator+1;
  }
  if (!m_qsSelectedAmount.isNull())
  {
    ComboBoxAmount->setEditText(m_qsSelectedAmount);
  }
}

void ZShopiAddDialog::accept()
{
  if (m_qsID.isNull())
  {
    if (ComboBoxGoods->currentItem() == 0)
    {
      QMessageBox::information( this, tr("Select a good!"), tr("You have to choose a good \n before you can press OK"));
    }
    else
    {
      QStringList qslistNewData;
      qslistNewData.append(m_qmapGoodID[ComboBoxGoods->currentItem()]);
      qslistNewData.append(m_qmapShopID[ComboBoxShops->currentItem()]);
      qslistNewData.append(ComboBoxAmount->currentText() + " " + TextLabelUnit->text());
      qslistNewData.append("0");

      m_poSQLite->Insert("cart",qslistNewData,"goodid, shopid, amount, done");

      ZShopiAddDialogDesign::accept();
    }
  }
  else
  {
    QString qsSet;
    qsSet = "amount = " + m_poSQLite->MakeCharVal(ComboBoxAmount->currentText() + " " + TextLabelUnit->text());
    qsSet = qsSet + ", " + "shopid = " + m_qmapShopID[ComboBoxShops->currentItem()];

    m_poSQLite->Update("cart", qsSet ,"id = " + m_qsID);
      
    ZShopiAddDialogDesign::accept();
  }
}
