/***************************************************************************
                          zshopiadddialog.h  -  description
                             -------------------
    begin                : Son Jul 20 2003
    copyright            : (C) 2003 by Bernd Lachner
    email                : dev@lachner-net.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef ZSHOPIADDDIALOG_H
#define ZSHOPIADDDIALOG_H

#include <qwidget.h>
#include <qmap.h>

#include "qsqlite.h"
#include <zshopiadddialogdesign.h>

/**
  *@author Bernd Lachner
  */

class ZShopiAddDialog : public ZShopiAddDialogDesign
{
   Q_OBJECT

   private:
    typedef QMap<int, QString> TComboMap;
    TComboMap m_qmapShopID;
    TComboMap m_qmapGoodsGroupID;
    TComboMap m_qmapGoodID;
    
    QSQLite *m_poSQLite;
    QString m_qsID;
    QString m_qsSelectedAmount;

   public:
    ZShopiAddDialog(QSQLite *poSQLite, QWidget* parent = 0, const char* name = 0, bool modal = FALSE, WFlags fl = 0);
    ZShopiAddDialog(QSQLite *poSQLite, const QString &qsID, QWidget* parent = 0, const char* name = 0, bool modal = FALSE, WFlags fl = 0);
    ~ZShopiAddDialog();

   protected slots:
    void RowDataShopList(int iColumns, char** aszData, char** aszColumnNames);
    void RowDataGoodsGroups(int iColumns, char** aszData, char** aszColumnNames);
    void RowDataGoods(int iColumns, char** aszData, char** aszColumnNames);
    void RowDataFindAmountGroupForGood(int iColumns, char** aszData, char** aszColumnNames);
    void RowDataSelectedGood(int iColumns, char** aszData, char** aszColumnNames);

    void slotGoodsGroupChanged(int iIndex);
    void slotGoodChanged(int iIndex);
    void accept();
};

#endif
