/***************************************************************************
                          zshopiaddnewamountgroup.cpp  -  description
                             -------------------
    begin                : Sam Nov 8 2003
    copyright            : (C) 2003 by Bernd Lachner
    email                : dev@lachner-net.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "zshopiaddnewamountgroup.h"

#include <qcombobox.h>
#include <qlineedit.h>
#include <qmessagebox.h>
#include <qpushbutton.h>
#include <qlayout.h>
#include <qgroupbox.h>

ZShopiAddNewAmountGroup::ZShopiAddNewAmountGroup(QSQLite *poSQLite, QWidget *parent, const char *name, bool modal, WFlags fl)
: ZShopiAddNewAmountGroupDesign(parent,name,modal, fl),
  m_poSQLite(poSQLite)
{
#ifdef QTOPIA
  PushButtonAccept->hide();
  PushButtonCancel->hide();
  LayoutMain->removeChild(LayoutButtons);
  delete LayoutButtons;
#endif
  adjustSize();
}

ZShopiAddNewAmountGroup::ZShopiAddNewAmountGroup(QSQLite *poSQLite, const QString &qsID,QWidget *parent, const char *name, bool modal, WFlags fl)
: ZShopiAddNewAmountGroupDesign(parent,name,modal, fl),
  m_poSQLite(poSQLite),
  m_qsID(qsID)
{
  m_poSQLite->Select(this, SLOT(RowDataAmountGroups(int, char**, char**)), "amountgroups","*", "ID = " + qsID);

  //change text at dialogs for Editing
  GroupBox->setTitle(tr("Edit Amount-Group"));
  setCaption(tr("Edit Amount-Group"));
  
#ifdef QTOPIA
  PushButtonAccept->hide();
  PushButtonCancel->hide();
  LayoutMain->removeChild(LayoutButtons);
  delete LayoutButtons;
#endif
  adjustSize();
}

ZShopiAddNewAmountGroup::~ZShopiAddNewAmountGroup()
{
}

void ZShopiAddNewAmountGroup::accept()
{
  if (LineEditAmountGroupName->text()=="" || LineEditAmountUnit->text()=="" || ComboBoxAmountNumbers->currentText()=="")
  {
    QMessageBox::information( this, tr("Fill lines!"), tr("All lines has to be filled \n before you can press OK"));
  }
  else
  {
    if (m_qsID.isNull())
    {
      QStringList qslistNewData;
      qslistNewData.append(LineEditAmountGroupName->text());
      qslistNewData.append(LineEditAmountUnit->text());
      qslistNewData.append(ComboBoxAmountNumbers->currentText());
      m_poSQLite->Insert("amountgroups",qslistNewData,"name, unit, numlist");
    }
    else
    {
      QString qsSet;
      qsSet = "name = " + QSQLite::MakeCharVal(LineEditAmountGroupName->text());
      qsSet += ", unit = " + QSQLite::MakeCharVal(LineEditAmountUnit->text());
      qsSet += ", numlist = " + QSQLite::MakeCharVal(ComboBoxAmountNumbers->currentText());
      m_poSQLite->Update("amountgroups", qsSet ,"id = " + m_qsID);
    }

    ZShopiAddNewAmountGroupDesign::accept();
  }
}

void ZShopiAddNewAmountGroup::RowDataAmountGroups(int iColumns, char** aszData, char** aszColumnNames)
{
  LineEditAmountGroupName->setText(aszData[1]);
  LineEditAmountUnit->setText(aszData[2]);
  ComboBoxAmountNumbers->setEditText(aszData[3]);
}

