/***************************************************************************
                          zshopiaddnewgood.cpp  -  description
                             -------------------
    begin                : Mon Jul 21 2003
    copyright            : (C) 2003 by Bernd Lachner
    email                : dev@lachner-net.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "zshopiaddnewgood.h"

#include <qcombobox.h>
#include <qlineedit.h>
#include <qpushbutton.h>
#include <qmessagebox.h>
#include <qlayout.h>
#include <qgroupbox.h>

ZShopiAddNewGood::ZShopiAddNewGood(QSQLite *poSQLite, QWidget* parent, const char* name, bool modal, WFlags fl)
: ZShopiAddNewGoodDesign(parent, name, modal, fl),
  m_poSQLite(poSQLite)
{
  m_poSQLite->Select(this, SLOT(RowDataGoodsGroups(int, char**, char**)), "category","*", "", "name");
  m_poSQLite->Select(this, SLOT(RowDataAmountGroups(int, char**, char**)), "amountgroups", "*", "", "name");
#ifdef QTOPIA
  PushButtonAccept->hide();
  PushButtonCancel->hide();
  LayoutMain->removeChild(LayoutButtons);
  delete LayoutButtons;
#endif
  adjustSize();
}

ZShopiAddNewGood::ZShopiAddNewGood(QSQLite *poSQLite, const QString &qsID, QWidget* parent, const char* name, bool modal, WFlags fl)
: ZShopiAddNewGoodDesign(parent, name, modal, fl),
  m_poSQLite(poSQLite),
  m_qsID(qsID)
{
  m_poSQLite->Select(this, SLOT(RowDataGoodsGroups(int, char**, char**)), "category");
  m_poSQLite->Select(this, SLOT(RowDataAmountGroups(int, char**, char**)), "amountgroups");
  m_poSQLite->Select(this, SLOT(RowDataGoodEdit(int, char**, char**)), "goods, category, amountgroups", "goods.id, goods.name, goods.category, goods.amountgroup" , "goods.id = " + qsID);

  //change text at dialogs for Editing
  GroupBox->setTitle(tr("Edit Good at Database"));
  setCaption(tr("Edit Good at Database"));
  
#ifdef QTOPIA
  PushButtonAccept->hide();
  PushButtonCancel->hide();
  LayoutMain->removeChild(LayoutButtons);
  delete LayoutButtons;
#endif
  adjustSize();
}

ZShopiAddNewGood::~ZShopiAddNewGood()
{
}

void ZShopiAddNewGood::RowDataGoodsGroups(int iColumns, char** aszData, char** aszColumnNames)
{
  ComboBoxGoodsGroups->insertItem(aszData[1]);
  int iIndex = ComboBoxGoodsGroups->count()-1;
  m_qmapGoodsGroupID[iIndex] = QString(aszData[0]);
}

void ZShopiAddNewGood::RowDataAmountGroups(int iColumns, char** aszData, char** aszColumnNames)
{
  ComboBoxAmountGroups->insertItem(aszData[1]);
  int iIndex = ComboBoxAmountGroups->count()-1;
  m_qmapAmountGroupID[iIndex] = QString(aszData[0]);
}

void ZShopiAddNewGood::RowDataGoodEdit(int iColumns, char** aszData, char** aszColumnNames)
{
  LineEditGoodName->setText(aszData[1]);
  TComboMap::Iterator it;
  for (it = m_qmapGoodsGroupID.begin(); it != m_qmapGoodsGroupID.end(); ++it)
  {
    if (it.data() == aszData[2])
    {
      ComboBoxGoodsGroups->setCurrentItem(it.key());
      break;
    }  
  }
  for (it = m_qmapAmountGroupID.begin(); it != m_qmapAmountGroupID.end(); ++it)
  {
    if (it.data() == aszData[3])
    {
      ComboBoxAmountGroups->setCurrentItem(it.key());
      break;
    }
  }  
}

void ZShopiAddNewGood::accept()
{
  if (LineEditGoodName->text() == "")
  {
    QMessageBox::information( this, tr("Enter a name!"), tr("You have to enter a name \n before you can press OK"));
  }
  else
  {
    QStringList qslistNewData;
    qslistNewData.append(LineEditGoodName->text());
    qslistNewData.append(m_qmapGoodsGroupID[ComboBoxGoodsGroups->currentItem()]);
    qslistNewData.append(m_qmapAmountGroupID[ComboBoxAmountGroups->currentItem()]);

    if (m_qsID.isNull())
    {
      m_poSQLite->Insert("goods",qslistNewData,"name, Category, amountgroup");
    }
    else
    {
      QString qsSet;
      qsSet = "name = " + QSQLite::MakeCharVal(LineEditGoodName->text());
      qsSet += ", category = " + m_qmapGoodsGroupID[ComboBoxGoodsGroups->currentItem()];
      qsSet += ", amountgroup = " + m_qmapAmountGroupID[ComboBoxAmountGroups->currentItem()];
      m_poSQLite->Update("goods", qsSet ,"goods.id = " + m_qsID);
    }
    
    ZShopiAddNewGoodDesign::accept();
  }
}

void ZShopiAddNewGood::slotTextChanged(const QString &qsText)
{
  if (qsText == "")
  {
    PushButtonAccept->setEnabled(FALSE);
  }
  else
  {
    PushButtonAccept->setEnabled(TRUE);
  }
}



