/***************************************************************************
                          zshopigoodsview.h  -  description
                             -------------------
    begin                : Son Jul 20 2003
    copyright            : (C) 2003 by Bernd Lachner
    email                : dev@lachner-net.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#ifndef ZSHOPIGOODSVIEW_H
#define ZSHOPIGOODSVIEW_H

#include <qwidget.h>

#include "qsqlite.h"
#include "zshopigoodsviewdesign.h"

/**
  *@author Bernd Lachner
  */

class ZShopiGoodsView : public ZShopiGoodsViewDesign
{
  Q_OBJECT

  public:
    ZShopiGoodsView(QSQLite *poSQLite, QWidget *parent=0);
    ~ZShopiGoodsView();
    void Refresh();

  private:
    QSQLite *m_poSQLite;
    QString m_qsEditGoodsGroupID;
    QString m_qsEditShopID; 
    void RefreshGoodsList();
    void RefreshGoodsGroupsList();
    void RefreshShopsList();
    void RefreshAmountGroupsList();

  protected slots:
    void slotTabChanged(QWidget*);
  
    void RowDataGoodsList(int iColumns, char** aszData, char** aszColumnNames);
    void slotDeleteGood();
    void slotEditGood();
    void slotAddGood();
    void slotGoodSelected();
    
    void RowDataGoodsGroupsList(int iColumns, char** aszData, char** aszColumnNames);
    void slotAddGoodsGroup();
    void slotDeleteGoodsGroup();
    void slotEditGoodsGroup();
    void slotTextNewGoodGroupChanged(const QString &qsText);
    void slotGoodGroupSelected();

    void RowDataShopList(int iColumns, char** aszData, char** aszColumnNames);
    void slotAddShop();
    void slotDeleteShop();
    void slotEditShop();
    void slotTextNewShopChanged(const QString &qsText);
    void slotShopSelected();

    void RowDataAmountGroups(int iColumns, char** aszData, char** aszColumnNames);
    void slotAddAmountGroup();
    void slotEditAmountGroup();
    void slotAmountGroupSelected();
    void slotDeleteAmountGroup();
};

#endif
