/***************************************************************************
                          zshopimainwidget.cpp  -  description
                             -------------------
    begin                : Son Jul 20 2003
    copyright            : (C) 2003 by Bernd Lachner
    email                : dev@lachner-net.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include <qlayout.h>
 
#include "zshopimainwidget.h"

ZShopiMainWidget::ZShopiMainWidget(QSQLite *poSQLite, QWidget *parent)
: QWidget(parent),
  m_iLastWidgetID(0)
{
  setCaption("ZShopi");
  QVBoxLayout *poMainLayout = new QVBoxLayout(this);
  m_poWidgetStack = new QWidgetStack(this);
  m_poZShopiView = new ZShopiView(poSQLite, this);
  m_poWidgetStack->addWidget(m_poZShopiView, 0);
  m_poZShopiGoodsView = new ZShopiGoodsView(poSQLite, this);
  m_poWidgetStack->addWidget(m_poZShopiGoodsView, 1);
  m_poWidgetStack->addWidget(new ZShopiPreferenceView(poSQLite, this), 2);
  m_poWidgetStack->raiseWidget(0);
  poMainLayout->addWidget(m_poWidgetStack);
  m_poComboBoxSwitch = new QComboBox(FALSE, this);
  poMainLayout->addWidget(m_poComboBoxSwitch);
  m_poComboBoxSwitch->insertItem(tr("Show Shopping Cart"));
  m_poComboBoxSwitch->insertItem(tr("Show Data (Goods, Shops, ...)"));
  m_poComboBoxSwitch->insertItem(tr("Preferences (Database import, ...)"));
  connect(m_poComboBoxSwitch, SIGNAL(activated(int)), SLOT(ChangeWidget(int)));
}                        

ZShopiMainWidget::~ZShopiMainWidget()
{
}

void ZShopiMainWidget::ChangeWidget(int iWidgetID)
{
  if (iWidgetID == 0)
    m_poZShopiView->Refresh();
  if (m_iLastWidgetID == 2)
    m_poZShopiGoodsView->Refresh();
  m_poWidgetStack->raiseWidget(iWidgetID);
  m_iLastWidgetID = iWidgetID;
}
