/***************************************************************************
                          zshopiview.cpp  -  description
                             -------------------
    begin                : Sam Jul 19 16:00:29 CEST 2003
    copyright            : (C) 2003 by Bernd Lachner
    email                : dev@lachner-net.de
 ***************************************************************************/

/***************************************************************************
 *                                                                         *
 *   This program is free software; you can redistribute it and/or modify  *
 *   it under the terms of the GNU General Public License as published by  *
 *   the Free Software Foundation; either version 2 of the License, or     *
 *   (at your option) any later version.                                   *
 *                                                                         *
 ***************************************************************************/

#include "zshopiview.h"
#include "zshopiadddialog.h"
#include "qlistviewextitem.h"

#include <qpushbutton.h>
#include <qpopupmenu.h>

ZShopiView::ZShopiView(QSQLite *poSQLite, QWidget *parent)
: ZShopiViewDesign(parent),
  m_poSQLite(poSQLite)                                            
{                                                                                      
  Refresh();
}                                                   

ZShopiView::~ZShopiView()
{
}

void ZShopiView::RowDataGoodsList(int iColumns, char** aszData, char** aszColumnNames)
{
  QCheckListExtItem *oListField = new QCheckListExtItem(ListViewShoppingList);
  oListField->setID(aszData[0]);
  if (aszData[4][0] == '1')
    oListField->setOn(true);
  else
    oListField->setOn(false);
  oListField->setText(1, aszData[1]);
  oListField->setText(3, aszData[2]);
  oListField->setText(2, aszData[3]);
  oListField->setText(4, aszData[5]); 
}

void ZShopiView::slotAddGoodToCart()
{
  ZShopiAddDialog oZShopiAddDialog(m_poSQLite, this, "ZShopiAddDialog", TRUE);
  oZShopiAddDialog.exec();
  ListViewShoppingList->clear();
  Refresh();
}

void ZShopiView::slotEditGoodInCart()
{
  QCheckListExtItem *poListViewItem = static_cast<QCheckListExtItem*>(ListViewShoppingList->selectedItem());
  if (poListViewItem != NULL)
  {
    ZShopiAddDialog oZShopiAddDialog(m_poSQLite, poListViewItem->getID(), this, "ZShopiAddDialog", TRUE);
    oZShopiAddDialog.exec();
    ListViewShoppingList->clear();
    Refresh();

    PushButtonDeleteGood->setEnabled(FALSE);
    PushButtonEditGood->setEnabled(FALSE);
  }
}

void ZShopiView::slotGoodClicked(QListViewItem *poClickedItem)
{
  if (poClickedItem != 0)
  {
    QCheckListExtItem* poCheckClickedItem = static_cast<QCheckListExtItem*>(poClickedItem);
    if (poCheckClickedItem->isOn())
      m_poSQLite->Update("cart", "done = '1'", "id = "+poCheckClickedItem->getID());
    else
      m_poSQLite->Update("cart", "done = '0'", "id = "+poCheckClickedItem->getID());  
  }
}    

void ZShopiView::slotGoodReturnPressed(QListViewItem *poClickedItem)
{
  if (poClickedItem != 0)
  {
    QCheckListExtItem* poCheckClickedItem = static_cast<QCheckListExtItem*>(poClickedItem);
    poCheckClickedItem->setOn(!poCheckClickedItem->isOn());
    if (poCheckClickedItem->isOn())
      m_poSQLite->Update("cart", "done = '1'", "id = "+poCheckClickedItem->getID());
    else
      m_poSQLite->Update("cart", "done = '0'", "id = "+poCheckClickedItem->getID());
  }
}

void ZShopiView::slotGoodFromCartSelected()
{
  PushButtonDeleteGood->setEnabled(TRUE);
  PushButtonEditGood->setEnabled(TRUE);
}

void ZShopiView::slotDeleteGoodFromCart()
{
  QCheckListExtItem *poListViewItem = static_cast<QCheckListExtItem*>(ListViewShoppingList->selectedItem());
  if (poListViewItem != NULL)
  {
    m_poSQLite->Delete("cart", "ID", poListViewItem->getID());
    delete poListViewItem;
    PushButtonDeleteGood->setEnabled(FALSE);
    PushButtonEditGood->setEnabled(FALSE);
  }
}

void ZShopiView::slotDeleteReadyGoods()
{
  m_poSQLite->Delete("cart", "done", "1");
  ListViewShoppingList->clear();
  PushButtonDeleteGood->setEnabled(FALSE);
  Refresh();
}

void ZShopiView::Refresh()
{
  ListViewShoppingList->clear();
  m_poSQLite->Select(this, SLOT(RowDataGoodsList(int, char**, char**)), "cart, goods, shops, category", "cart.id, goods.name, shops.name, cart.amount, cart.done, category.name", "cart.goodid = goods.id AND cart.shopid = shops.id AND category.id = goods.category");
  PushButtonDeleteGood->setEnabled(FALSE);
  PushButtonEditGood->setEnabled(FALSE);
}
